• Willkommen im Linux Club - dem deutschsprachigen Supportforum für GNU/Linux. Registriere dich kostenlos, um alle Inhalte zu sehen und Fragen zu stellen.

eigener startup script automatisch starten

cc

Member
hallo

mein system ist opensuse 10.0
habe ein wpasupplicant startup script erstellt und zum verzeichnis /etc/init.d hingefügt.

jetzt kann ich mit:
Code:
# /etc/init.d/wpasupplicant start
starten und er macht sein job.

möchte aber automatisch beim system start starten.
habe folgendes gemacht:
Code:
# cd /etc/init.d
linux:/etc/init.d # ln -s  wpasupplicant /etc/init.d/rc5.d/S25wpasupplicant
und über yast -> system -> runlevel editor aktiviert.

leider will der script nicht automatisch starten.

weiss jemand wie ich das problem beheben kann ?
 

oc2pus

Ultimate Guru
zeige uns mal dein Script ...

und beachte das HowTo im FAQ-Forum zur Erstellung eigener Runlevel-Scripte
 
OP
C

cc

Member
Code:
#! /bin/sh

# Check for missing binaries (stale symlinks should not happen)
# Note: Special treatment of stop for LSB conformance
FOO_BIN=/usr/local/sbin/wpa_supplicant
test -x $FOO_BIN || { echo "$FOO_BIN not installed"; 
	if [ "$1" = "stop" ]; then exit 0;
	else exit 5; fi; }

# Check for existence of needed config file and read it
FOO_CONFIG=/etc/wpa_supplicant.conf
test -r $FOO_CONFIG || { echo "$FOO_CONFIG not existing";
	if [ "$1" = "stop" ]; then exit 0;
	else exit 6; fi; }

# Read config	
#. $FOO_CONFIG

# Source LSB init functions
# providing start_daemon, killproc, pidofproc, 
# log_success_msg, log_failure_msg and log_warning_msg.
# This is currently not used by UnitedLinux based distributions and
# not needed for init scripts for UnitedLinux only. If it is used,
# the functions from rc.status should not be sourced or used.
#. /lib/lsb/init-functions

# Shell functions sourced from /etc/rc.status:
#      rc_check         check and set local and overall rc status
#      rc_status        check and set local and overall rc status
#      rc_status -v     be verbose in local rc status and clear it afterwards
#      rc_status -v -r  ditto and clear both the local and overall rc status
#      rc_status -s     display "skipped" and exit with status 3
#      rc_status -u     display "unused" and exit with status 3
#      rc_failed        set local and overall rc status to failed
#      rc_failed <num>  set local and overall rc status to <num>
#      rc_reset         clear both the local and overall rc status
#      rc_exit          exit appropriate to overall rc status
#      rc_active        checks whether a service is activated by symlinks
#      rc_splash arg    sets the boot splash screen to arg (if active)
. /etc/rc.status

# Reset status of this service
rc_reset

# Return values acc. to LSB for all commands but status:
# 0	  - success
# 1       - generic or unspecified error
# 2       - invalid or excess argument(s)
# 3       - unimplemented feature (e.g. "reload")
# 4       - user had insufficient privileges
# 5       - program is not installed
# 6       - program is not configured
# 7       - program is not running
# 8--199  - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
# 
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signaling is not supported) are
# considered a success.

case "$1" in
    start)
	echo -n "Starting wpa_supplicant "
	## Start daemon with startproc(8). If this fails
	## the return value is set appropriately by startproc.
	startproc $FOO_BIN -Bw -iath0 -Dmadwifi -c/etc/wpa_supplicant.conf 

	# Remember status and be verbose
	rc_status -v
	;;
    stop)
	echo -n "Shutting down wpa_supplicant "
	## Stop daemon with killproc(8) and if this fails
	## killproc sets the return value according to LSB.

	killproc -TERM $FOO_BIN

	# Remember status and be verbose
	rc_status -v
	;;
    try-restart|condrestart)
	## Do a restart only if the service was active before.
	## Note: try-restart is now part of LSB (as of 1.9).
	## RH has a similar command named condrestart.
	if test "$1" = "condrestart"; then
		echo "${attn} Use try-restart ${done}(LSB)${attn} rather than condrestart ${warn}(RH)${norm}"
	fi
	$0 status
	if test $? = 0; then
		$0 restart
	else
		rc_reset	# Not running is not a failure.
	fi
	# Remember status and be quiet
	rc_status
	;;
    restart)
	## Stop the service and regardless of whether it was
	## running or not, start it again.
	$0 stop
	$0 start

	# Remember status and be quiet
	rc_status
	;;
    force-reload)
	## Signal the daemon to reload its config. Most daemons
	## do this on signal 1 (SIGHUP).
	## If it does not support it, restart.

	echo -n "Reload service FOO "
	## if it supports it:
	killproc -HUP $FOO_BIN
	#touch /var/run/FOO.pid
	rc_status -v

	## Otherwise:
	#$0 try-restart
	#rc_status
	;;
    reload)
	## Like force-reload, but if daemon does not support
	## signaling, do nothing (!)

	# If it supports signaling:
	echo -n "Reload service FOO "
	killproc -HUP $FOO_BIN
	#touch /var/run/FOO.pid
	rc_status -v
	
	## Otherwise if it does not support reload:
	#rc_failed 3
	#rc_status -v
	;;
    status)
	echo -n "Checking for service wpa_supplicant "
	## Check status with checkproc(8), if process is running
	## checkproc will return with exit status 0.

	# Return value is slightly different for the status command:
	# 0 - service up and running
	# 1 - service dead, but /var/run/  pid  file exists
	# 2 - service dead, but /var/lock/ lock file exists
	# 3 - service not running (unused)
	# 4 - service status unknown :-(
	# 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)
	
	# NOTE: checkproc returns LSB compliant status values.
	checkproc $FOO_BIN
	# NOTE: rc_status knows that we called this init script with
	# "status" option and adapts its messages accordingly.
	rc_status -v
	;;
    probe)
	## Optional: Probe for the necessity of a reload, print out the
	## argument to this init script which is required for a reload.
	## Note: probe is not (yet) part of LSB (as of 1.9)

	test /etc/FOO/FOO.conf -nt /var/run/FOO.pid && echo reload
	;;
    *)
	echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload|probe}"
	exit 1
	;;
esac
rc_exit
 

oc2pus

Ultimate Guru
dir fehlt dieser Block (hier von /etc/init.d/named als Beispiel) am Anfang:
Code:
### BEGIN INIT INFO
# Provides:          named
# Required-Start:    $network $remote_fs $syslog
# Required-Stop:     $network $remote_fs $syslog
# Should-Start:      ldap
# Default-Start:     3 5
# Default-Stop:      0 1 2 6
# Short-Description: Domain Name System (DNS) server, named
# Description:       Berkeley Internet Name Domain (BIND) implementation of the
#       Domain Name System (DNS) server named.
### END INIT INFO

dann kannst du mit insserv <deinDienst> den Dienst in die Boot-Reihenfolge integrieren.
 
OP
C

cc

Member
habe gemäss:

http://ndiswrapper.sourceforge.net/mediawiki/index.php/Suse_Professional_9.x#Making_wpa_work_at_boot

gemacht und der script startet jetzt !

er startet erst nach dem network und nicht vorher, bzw. die wireless interface hat zu wenig zeit,
um die verbindung zu bekommen.

er muss aber VOR dem ath0 gestartet werden, da das ath0 eine funktionierende physikalische Netzwerkverbindung voraussetzt.
Code:
# vi /var/log/boot.msg 

Setting up network interfaces:
    lo
    lo        IP address: 127.0.0.1/8
done    ath0      device: Atheros Communications, Inc. AR5212 802.11abg NIC (rev 01)
    ath0      configuration: wlan-id-00:0f:b5:25:b2:b8
    ath0      warning: using NO encryption
    ath0      IP address: 192.168.200.10/24
done    eth0      device: Intel Corporation 82541PI Gigabit Ethernet Controller (rev 05)
    eth0      No configuration found for eth0
unused    eth1      device: VIA Technologies, Inc. VT6102 [Rhine-II] (rev 74)
    eth1      No configuration found for eth1
unusedSetting up service network  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .  .done
<notice>startproc: execve (/sbin/portmap) [ /sbin/portmap ], [ CONSOLE=/dev/console ROOTFS_FSTYPE=ext3 TERM=linux SHELL=/bin/sh ROOTFS_FSCK=0 LC_ALL=POSIX INIT_VERSION=sysvinit-2.85 REDIRECT=/dev/tty1 COLUMNS=99 PATH=/sbin:/usr/sbin:/bin:/usr/bin:/lib/klibc/bin vga=788 RUNLEVEL=5 PWD=/ SPLASHCFG=/etc/bootsplash/themes/SuSE/config/bootsplash-800x600.cfg PREVLEVEL=N LINES=34 HOME=/ SHLVL=2 splash=silent SPLASH=yes ROOTFS_BLKDEV=/dev/hdb7 _=/sbin/startproc DAEMON=/sbin/portmap ]
<notice>startproc: execve (/usr/sbin/mdnsd) [ /usr/sbin/mdnsd -f /etc/nss_mdns.conf -b ], [ CONSOLE=/dev/console ROOTFS_FSTYPE=ext3 TERM=linux SHELL=/bin/sh ROOTFS_FSCK=0 LC_ALL=POSIX INIT_VERSION=sysvinit-2.85 REDIRECT=/dev/tty1 COLUMNS=99 PATH=/sbin:/usr/sbin:/bin:/usr/bin:/lib/klibc/bin vga=788 RUNLEVEL=5 PWD=/ SPLASHCFG=/etc/bootsplash/themes/SuSE/config/bootsplash-800x600.cfg PREVLEVEL=N LINES=34 HOME=/ SHLVL=2 splash=silent SPLASH=yes ROOTFS_BLKDEV=/dev/hdb7 _=/sbin/startproc DAEMON=/usr/sbin/mdnsd ]
Starting RPC portmap daemondone
<notice>startproc: execve (/usr/local/sbin/wpa_supplicant) [ /usr/local/sbin/wpa_supplicant -iath0 -Dmadwifi -c/etc/wpa_supplicant.conf -Bw ], [ CONSOLE=/dev/console ROOTFS_FSTYPE=ext3 TERM=linux SHELL=/bin/sh ROOTFS_FSCK=0 LC_ALL=POSIX INIT_VERSION=sysvinit-2.85 REDIRECT=/dev/tty1 COLUMNS=99 PATH=/sbin:/usr/sbin:/bin:/usr/bin:/lib/klibc/bin vga=788 RUNLEVEL=5 PWD=/ SPLASHCFG=/etc/bootsplash/themes/SuSE/config/bootsplash-800x600.cfg PREVLEVEL=N LINES=34 HOME=/ SHLVL=2 splash=silent SPLASH=yes ROOTFS_BLKDEV=/dev/hdb7 _=/sbin/startproc DAEMON=/usr/local/sbin/wpa_supplicant ]
in /etc/sysconfig/network/config habe:
"WAIT_FOR_INTERFACES" auf 30 geändert, hilft aber nicht.

hat jemand Idee, wie man dieses problem lösen kann ?
 
OP
C

cc

Member
dies scheint zu funktionieren:
Code:
#! /bin/sh

### BEGIN INIT INFO
# Provides:          wpa
# Required-Start:    $local_fs
# Should-Start: coldplug pcmcia
# Required-Stop:     
# Should-Stop: 
# Default-Start:     2 3 5
# Default-Stop:      
# Short-Description: wpa_supplicant providing WPA
# Description:       Start wpa_supplicant to allow network and provide WPA
### END INIT INFO

# Check for missing binaries (stale symlinks should not happen)
# Note: Special treatment of stop for LSB conformance
FOO_BIN=/usr/local/sbin/wpa_supplicant
test -x $FOO_BIN || { echo "$FOO_BIN not installed"; 
	if [ "$1" = "stop" ]; then exit 0;
	else exit 5; fi; }

# Check for existence of needed config file and read it
FOO_CONFIG=/etc/wpa_supplicant.conf
test -r $FOO_CONFIG || { echo "$FOO_CONFIG not existing";
	if [ "$1" = "stop" ]; then exit 0;
	else exit 6; fi; }

# Read config	
#. $FOO_CONFIG

# Source LSB init functions
# providing start_daemon, killproc, pidofproc, 
# log_success_msg, log_failure_msg and log_warning_msg.
# This is currently not used by UnitedLinux based distributions and
# not needed for init scripts for UnitedLinux only. If it is used,
# the functions from rc.status should not be sourced or used.
#. /lib/lsb/init-functions

# Shell functions sourced from /etc/rc.status:
#      rc_check         check and set local and overall rc status
#      rc_status        check and set local and overall rc status
#      rc_status -v     be verbose in local rc status and clear it afterwards
#      rc_status -v -r  ditto and clear both the local and overall rc status
#      rc_status -s     display "skipped" and exit with status 3
#      rc_status -u     display "unused" and exit with status 3
#      rc_failed        set local and overall rc status to failed
#      rc_failed <num>  set local and overall rc status to <num>
#      rc_reset         clear both the local and overall rc status
#      rc_exit          exit appropriate to overall rc status
#      rc_active        checks whether a service is activated by symlinks
#      rc_splash arg    sets the boot splash screen to arg (if active)
. /etc/rc.status

# Reset status of this service
rc_reset

# Return values acc. to LSB for all commands but status:
# 0	  - success
# 1       - generic or unspecified error
# 2       - invalid or excess argument(s)
# 3       - unimplemented feature (e.g. "reload")
# 4       - user had insufficient privileges
# 5       - program is not installed
# 6       - program is not configured
# 7       - program is not running
# 8--199  - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
# 
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signaling is not supported) are
# considered a success.

case "$1" in
    start)
	echo -n "Starting wpa_supplicant "
	## Start daemon with startproc(8). If this fails
	## the return value is set appropriately by startproc.
	startproc $FOO_BIN -Bw -iath0 -c/etc/wpa_supplicant.conf -Dmadwifi

	# Remember status and be verbose
	rc_status -v
	;;
    stop)
	echo -n "Shutting down wpa_supplicant "
	## Stop daemon with killproc(8) and if this fails
	## killproc sets the return value according to LSB.

	killproc -TERM $FOO_BIN

	# Remember status and be verbose
	rc_status -v
	;;
    try-restart|condrestart)
	## Do a restart only if the service was active before.
	## Note: try-restart is now part of LSB (as of 1.9).
	## RH has a similar command named condrestart.
	if test "$1" = "condrestart"; then
		echo "${attn} Use try-restart ${done}(LSB)${attn} rather than condrestart ${warn}(RH)${norm}"
	fi
	$0 status
	if test $? = 0; then
		$0 restart
	else
		rc_reset	# Not running is not a failure.
	fi
	# Remember status and be quiet
	rc_status
	;;
    restart)
	## Stop the service and regardless of whether it was
	## running or not, start it again.
	$0 stop
	$0 start

	# Remember status and be quiet
	rc_status
	;;
    force-reload)
	## Signal the daemon to reload its config. Most daemons
	## do this on signal 1 (SIGHUP).
	## If it does not support it, restart.

	echo -n "Reload service FOO "
	## if it supports it:
	killproc -HUP $FOO_BIN
	#touch /var/run/FOO.pid
	rc_status -v

	## Otherwise:
	#$0 try-restart
	#rc_status
	;;
    reload)
	## Like force-reload, but if daemon does not support
	## signaling, do nothing (!)

	# If it supports signaling:
	echo -n "Reload service FOO "
	killproc -HUP $FOO_BIN
	#touch /var/run/FOO.pid
	rc_status -v
	
	## Otherwise if it does not support reload:
	#rc_failed 3
	#rc_status -v
	;;
    status)
	echo -n "Checking for service wpa_supplicant "
	## Check status with checkproc(8), if process is running
	## checkproc will return with exit status 0.

	# Return value is slightly different for the status command:
	# 0 - service up and running
	# 1 - service dead, but /var/run/  pid  file exists
	# 2 - service dead, but /var/lock/ lock file exists
	# 3 - service not running (unused)
	# 4 - service status unknown :-(
	# 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)
	
	# NOTE: checkproc returns LSB compliant status values.
	checkproc $FOO_BIN
	# NOTE: rc_status knows that we called this init script with
	# "status" option and adapts its messages accordingly.
	rc_status -v
	;;
    probe)
	## Optional: Probe for the necessity of a reload, print out the
	## argument to this init script which is required for a reload.
	## Note: probe is not (yet) part of LSB (as of 1.9)

	test /etc/FOO/FOO.conf -nt /var/run/FOO.pid && echo reload
	;;
    *)
	echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload|probe}"
	exit 1
	;;
esac
rc_exit

musste aber in /etc/init.d/network noch folgendes anpassen:
Code:
### BEGIN INIT INFO
# Provides:       network
# Required-Start: $local_fs wpa
# Should-Start: isdn
# Required-Stop:
# Should-Stop:
# Default-Start:  2 3 5
# Default-Stop:
# Description:    Configure the network interfaces and set up routing
### END INIT INFO

gruss
cc
 
Oben